<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UnOrderedExecutionExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.executor</a> &gt; <span class="el_source">UnOrderedExecutionExchange.java</span></div><h1>UnOrderedExecutionExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.executor;

import java.util.Objects;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicReferenceArray;
import java.util.function.Consumer;
import java.util.function.IntFunction;
import java.util.function.Supplier;
import java.util.stream.IntStream;

import io.gitlab.littlesaints.protean.Constants;
import io.gitlab.littlesaints.protean.NamedForkJoinWorkerThread;
import io.gitlab.littlesaints.protean.Processor;
import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;
import io.gitlab.littlesaints.protean.resources.Registrar;

/**
 * This executor performs un-ordered executions.
 * There's no order in execution for submitted objects.
 *
 * @param &lt;E&gt; The getType of objects to execute upon.
 * @author Varun Anand
 * @since 1.0
 */
public class UnOrderedExecutionExchange&lt;E&gt; extends AbstractExecutionExchange&lt;E&gt; {

	public static final String TYPE = &quot;protean::exchange::execution::unordered&quot;;

<span class="fc" id="L52">	public static class _Registrar implements Registrar {</span>
		static {
<span class="fc" id="L54">			MessageExchange.REGISTRY.register(TYPE, UnOrderedExecutionExchange::new);</span>
<span class="fc" id="L55">		}</span>

		@Override
		public String toString() {
<span class="fc" id="L59">			return &quot;UnOrderedExecutionExchange::Registrar&quot;;</span>
		}
	}

	private static final String nameSuffix = &quot;::UnOrderedExecutionExchange&quot;;

	private final ExecutorService executor;
	private final Reader&lt;E&gt; reader;
	private final Reader&lt;E&gt;[] outputExchangeReaders;
	private final Writer&lt;E&gt;[] outputExchangeWriters;

	private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; inputExchanges;
	private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; outputExchanges;

	private class _WorkerThread extends NamedForkJoinWorkerThread {

		private final Consumer&lt;E&gt; action;

<span class="fc" id="L77">		_WorkerThread(String name, ForkJoinPool pool, Processor&lt;E&gt; processor) {</span>
<span class="fc" id="L78">			super(name, pool, processor::close);</span>
<span class="fc" id="L79">			this.action = processor.getFunction()::apply;</span>
<span class="fc" id="L80">		}</span>

		void execute(E e) {
<span class="fc" id="L83">			action.accept(e);</span>
<span class="fc" id="L84">			outputExchangeWriters[getPoolIndex()].put(e);</span>
<span class="fc" id="L85">		}</span>
	}

	private UnOrderedExecutionExchange(final int capacity, final boolean isMultiProducer, final Config config) {
<span class="fc" id="L89">		this(config.getOrDefault(Constants.NAME, System.currentTimeMillis() + &quot;&quot;) + nameSuffix, config.&lt;Integer&gt;getOrDefault(Constants.CONCURRENCY, Runtime.getRuntime().availableProcessors()), capacity,</span>
<span class="fc" id="L90">			config.get(Constants.Exchange.EXCHANGE_SUPPLIER), config.get(Constants.Exchange.PROCESSOR_SUPPLIER));</span>
<span class="fc" id="L91">	}</span>

	/**
	 * Construct an executor
	 *
	 * @param name             the name of this exchange. Pass null, if no specific value is needed.
	 * @param concurrency      the 'fixed' number of threads to use
	 * @param capacity         the buffer size of each thread's message exchange
	 * @param exchangeSupplier the supplier function for creating a message exchange
	 * @param processorSupplier   the processorSupplier to perform on a submitted object/event
	 */
	private UnOrderedExecutionExchange(String name, int concurrency, int capacity, IntFunction&lt;MessageExchange&lt;E&gt;&gt; exchangeSupplier,
									   Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier) {
<span class="fc" id="L104">		super(name, processorSupplier, concurrency, exchangeSupplier);</span>

<span class="fc" id="L106">		inputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L107">		outputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>

<span class="fc" id="L109">		reader = new _Reader();</span>

<span class="fc" id="L111">		outputExchangeReaders = new Reader[concurrency];</span>
<span class="fc" id="L112">		outputExchangeWriters = new Writer[concurrency];</span>

<span class="fc" id="L114">		IntStream.range(0, concurrency).forEach(i -&gt; {</span>
<span class="fc" id="L115">			MessageExchange&lt;E&gt; exchange = exchangeSupplier.apply(capacity);</span>
<span class="fc" id="L116">			outputExchangeReaders[i] = exchange.getReader();</span>
<span class="fc" id="L117">			outputExchangeWriters[i] = exchange.newWriter();</span>
<span class="fc" id="L118">			inputExchanges.set(i, exchange);</span>
<span class="fc" id="L119">		});</span>

<span class="fc" id="L121">		this.executor = new ForkJoinPool(concurrency, p -&gt; new _WorkerThread(name, p, processorSupplier.get()), null, true);</span>

<span class="fc" id="L123">	}</span>

<span class="fc" id="L125">	private class _Writer implements Writer&lt;E&gt; {</span>
		@Override
		public boolean put(final E e) {
		    //TODO:: can we do better ?
<span class="fc" id="L129">			executor.submit(() -&gt; ((_WorkerThread) Thread.currentThread()).execute(e));</span>
<span class="fc" id="L130">			return true;</span>
		}
	}

<span class="fc" id="L134">	private class _Reader extends _ExecutionExchangeReader {</span>
		@Override
		Reader&lt;E&gt; getOutputExchangeReader(int idx) {
<span class="fc" id="L137">			return outputExchangeReaders[idx];</span>
		}
	}

	@Override
	public Writer&lt;E&gt; newWriter() {
<span class="fc" id="L143">		return new _Writer();</span>
	}

	@Override
	public Reader&lt;E&gt; getReader() {
<span class="fc" id="L148">		return reader;</span>
	}

	@Override
	public void shutdown() {
//		while (!isEmpty()) {
//			Thread.yield();
//		}
<span class="nc" id="L156">		IntStream.range(0, concurrency)</span>
<span class="nc" id="L157">			.boxed()</span>
<span class="nc" id="L158">			.map(inputExchanges::get)</span>
<span class="nc" id="L159">			.filter(Objects::nonNull)</span>
<span class="nc" id="L160">			.forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L161">		IntStream.range(0, concurrency)</span>
<span class="nc" id="L162">			.boxed()</span>
<span class="nc" id="L163">			.map(outputExchanges::get)</span>
<span class="nc" id="L164">			.filter(Objects::nonNull)</span>
<span class="nc" id="L165">			.forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L166">		executor.shutdown();</span>
<span class="nc bnc" id="L167" title="All 2 branches missed.">		while (!executor.isShutdown()) {</span>
			try {
<span class="nc" id="L169">				executor.awaitTermination(1, TimeUnit.MILLISECONDS);</span>
<span class="nc" id="L170">			} catch (InterruptedException e) {</span>
				//TODO logging
<span class="nc" id="L172">				e.printStackTrace();</span>
<span class="nc" id="L173">			}</span>
		}
<span class="nc" id="L175">	}</span>

	@Override
	public boolean isEmpty() {
<span class="nc" id="L179">		return IntStream.range(0, concurrency)</span>
<span class="nc" id="L180">			.boxed()</span>
<span class="nc" id="L181">			.map(inputExchanges::get)</span>
<span class="nc" id="L182">			.filter(Objects::nonNull)</span>
<span class="nc" id="L183">			.map(MessageExchange::isEmpty)</span>
<span class="nc bnc" id="L184" title="All 4 branches missed.">			.reduce((e1, e2) -&gt; e1 &amp;&amp; e2)</span>
<span class="nc" id="L185">			.orElse(Boolean.FALSE);</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>